=begin
#日本語
#utf-8 without BOM
#fill the inside of solid with the construction points.
#Autoher:TAK2HATA
Strongly Recommend Sketchup version 8 higher for using this.
The copyright of this plug-in is in TAK2HATA. 
Please use this plug-in in self-responsibility. 
I do not take any responsibility. 
You can use freely. 
=end

require 'sketchup.rb'
class FillCpoints
def erase_edges_out_of_solids
	model = Sketchup.active_model
	aents = model.active_entities
	sels = model.selection
	return if sels.count <= 0
	density = 100 / ( 1.m ** 3 )
	tcount = 0
	pcount = 0
	erase_edges = []
	erase_ids = []
	solidlist= []
	sels.each{|sel|
		if sel.kind_of? Sketchup::Group or sel.kind_of? Sketchup::ComponentInstance
			if sel.volume != nil and sel.volume > 0.0
				solidlist.push sel
			end
		end
	}
	aents.find_all{|e| e.kind_of? Sketchup::Edge }.each{|ed|
		pt1 = ed.start.position
		pt2 = ed.end.position
		pt3 = Geom.linear_combination( 0.5, pt1, 0.5, pt2 )
		chk = false
		solidlist.each{|solid|
			if is_in_solid( pt3 , solid ) == true
				#p "in solid"
				chk = true
				break
			end
		}
		if chk == false
			if erase_ids.index( ed.entityID ) == nil
				erase_edges.push ed
				erase_ids.push ed.entityID
			end
		end
	}
	p erase_edges.size
	aents.erase_entities erase_edges
end
def fill_bycpoint
	model = Sketchup.active_model
	aents = model.active_entities
	sels = model.selection
	return if sels.count <= 0
	density = 100 / ( 1.m ** 3 )
	tcount = 0
	pcount = 0
	sels.each{|sel|
		if sel.kind_of? Sketchup::Group or sel.kind_of? Sketchup::ComponentInstance
			if sel.volume != nil and sel.volume > 0.0
				pcount = ( sel.volume * density ).to_i
				pcount = 1000 if pcount > 1000
				bb = sel.bounds
				j = 0
				( pcount * 4 ).times{|i|
					break if pcount < j
					pt = Geom::Point3d.new( 0,0,0 )
					pt.x = ( bb.max.x - bb.min.x ) * rand + bb.min.x
					pt.y = ( bb.max.y - bb.min.y ) * rand + bb.min.y
					pt.z = ( bb.max.z - bb.min.z ) * rand + bb.min.z
					if is_in_solid( pt , sel ) == true
						aents.add_cpoint( pt )
						Sketchup.set_status_text "add cpoint#{tcount}"
						tcount += 1
						j += 1
					end
				}
			end
		end
	}
	UI.messagebox "#{tcount}/#{pcount} cpoints created"
end
##test  is_in_solid( [0,0,0] , Sketchup.active_model.selection[0] )
def is_in_solid( opt , solid )
	if solid.kind_of? Sketchup::Group
		sotr = solid.transformation
		opt2 = opt#.transform( solid.transformation.inverse )
		opt3 = Geom::Point3d.new(0,0,0)
		opt3 = Geom::Point3d.new(0,0,100) if opt2.vector_to(opt3) == 0.0
		line = [ opt2 , opt3 ]
		lvec= opt2.vector_to( opt3 ).normalize
		pvol = 0.0
		pts = []
		fcs = solid.entities.find_all{|e| e.kind_of? Sketchup::Face }
		fcs.each{|fc|
			clf = fc.classify_point( opt2.transform( sotr.inverse ) )
			return true if clf != 0 and clf < 16
		}
		fcs.each{|fc|
			#plane = fc.plane
			plane = [ fc.vertices[0].position.transform( sotr ) , fc.normal.transform( sotr ) ]
			ppt = Geom.intersect_line_plane(line, plane)
			if ppt != nil
				clf = fc.classify_point( ppt.transform( sotr.inverse ) )
				
				if clf != 0 and clf < 16
					#p "clf=#{clf}"
					pts.push ppt
					#line intersect with face
				else
					#line not intersect
				end
			end
		}
		sptcount = 0
		pts.each{|pt|
			#opt2から見て同じベクトルの方向にあるものをカウントする
			if ( opt2.vector_to( pt ).normalize - lvec ).length < 0.1
				sptcount += 1
			end
		}
		#p "sptcount=#{sptcount}"
		#sptcountが偶数ならソリッドの外、奇数ならソリッドの中
		if ( sptcount % 2 ) == 1
			return true
		else
			return false
		end
	end
end
def get_solid_volume( opt , solid )
	if solid.kind_of? Sketchup::Group
		opt2 = opt.transform( solid.transformation )
		pvol = 0.0
		solid.entities.find_all{|e| e.kind_of? Sketchup::Face }.each{|fc|
			plane = fc.plane
			nor = fc.normal
			ppt = opt2.project_to_plane( plane )
			vol = fc.area * opt2.distance_to_plane( plane ) / 3
			#if ppt.vector_to(opt2).samedirecton?(nor)
			p "vector length #{( ppt.vector_to(opt2).normalize - nor ).length}"
			if ( ppt.vector_to(opt2).normalize - nor ).length < 0.5
				vol = - vol
			end
			p "volumes #{vol}"
			pvol = pvol + vol
		}
		p "total volume #{pvol}"
		if pvol / solid.volume > 0.95
			return true
		else
			return false
		end
	end
end
end

if( not file_loaded?("fill_cpoints.rb") )
	UI.menu("Plugins").add_item("fill_cpoints"){ 
		fcp = FillCpoints.new
		fcp.fill_bycpoint
	}
	UI.menu("Plugins").add_item("erase edges out of solids"){ 
		fcp = FillCpoints.new
		fcp.erase_edges_out_of_solids
	}
end

file_loaded("fill_cpoints.rb")